Index: plugins/tools/selectiontools/kis_tool_select_brush.cc
===================================================================
--- plugins/tools/selectiontools/kis_tool_select_brush.cc	(revision 1177751)
+++ plugins/tools/selectiontools/kis_tool_select_brush.cc	(working copy)
@@ -49,7 +49,6 @@
 KisToolSelectBrush::KisToolSelectBrush(KoCanvasBase * canvas)
         : KisToolSelectBase(canvas, KisCursor::load("tool_brush_selection_cursor.png", 6, 6)),
         m_brushRadius(15),
-        m_dragging(false),
         m_lastMousePosition(-1, -1)
 {
     resetSelection();
@@ -86,7 +85,7 @@
 void KisToolSelectBrush::paint(QPainter& gc, const KoViewConverter &converter)
 {
     Q_UNUSED(converter);
-    if(m_dragging) {
+    if(mode() == KisTool::PAINT_MODE) {
         paintToolOutline(&gc, pixelToView(m_selection));
     }
     else  if(m_lastMousePosition!=QPoint(-1, -1)) {
@@ -96,27 +95,51 @@
     }
 }
 
-void KisToolSelectBrush::mousePressEvent(KoPointerEvent *e)
+void KisToolSelectBrush::mousePressEvent(KoPointerEvent *event)
 {
-    if (e->button() == Qt::LeftButton) {
-        m_dragging = true;
-        m_lastPoint=convertToPixelCoord(e->point);
-        addPoint(convertToPixelCoord(e->point));
-        e->accept();
+    if(mode() == KisTool::PAINT_MODE) {
+        /**
+         * Cancalling must be done at KisTool level
+         */
+//        resetSelection();
+//        return;
     }
-    else if (e->button()==Qt::RightButton || e->button()==Qt::MidButton) {
-        m_dragging = false;
-        resetSelection();
-        e->accept();
+
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
+
+        setMode(KisTool::PAINT_MODE);
+
+        m_lastPoint = convertToPixelCoord(event->point);
+        addPoint(m_lastPoint);
     }
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
-void KisToolSelectBrush::mouseMoveEvent(KoPointerEvent *e)
+void KisToolSelectBrush::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_dragging) {
+    /**
+     * Update outline
+     */
+    QRect brushRect(-m_brushRadius, -m_brushRadius, 2*m_brushRadius, 2*m_brushRadius);
+    brushRect.adjust(-2, -2, 2, 2);     //width of tool outline
 
+    brushRect.moveCenter(m_lastMousePosition);
+    updateCanvasPixelRect(brushRect);
+
+    m_lastMousePosition = convertToPixelCoord(event).toPoint();
+
+    brushRect.moveCenter(m_lastMousePosition);
+    updateCanvasPixelRect(brushRect);
+
+    /**
+     * Do selection
+     */
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
         // this gives better performance
-        if(Vector2f((m_lastPoint-convertToPixelCoord(e->point)).x(), (m_lastPoint-convertToPixelCoord(e->point)).y()).norm()<m_brushRadius/6)
+        if(Vector2f((m_lastPoint-convertToPixelCoord(event->point)).x(), (m_lastPoint-convertToPixelCoord(event->point)).y()).norm()<m_brushRadius/6)
             return;
 
         //randomise the point to workaround a bug in QPainterPath::operator|=()
@@ -127,29 +150,22 @@
         qreal randomY=rand()%100;
         randomY/=1000.;
         QPointF smallRandomPoint(randomX, randomY);
-        addPoint(convertToPixelCoord(e->point)+smallRandomPoint);
+        addPoint(convertToPixelCoord(event->point)+smallRandomPoint);
     }
     else {
-        QRect brushRect(-m_brushRadius, -m_brushRadius, 2*m_brushRadius, 2*m_brushRadius);
-        brushRect.adjust(-2, -2, 2, 2);     //width of tool outline
-
-        brushRect.moveCenter(m_lastMousePosition);
-        updateCanvasPixelRect(brushRect);
-
-        m_lastMousePosition = convertToPixelCoord(e).toPoint();
-
-        brushRect.moveCenter(m_lastMousePosition);
-        updateCanvasPixelRect(brushRect);
+        KisTool::mouseMoveEvent(event);
     }
 }
 
-void KisToolSelectBrush::mouseReleaseEvent(KoPointerEvent *e)
+void KisToolSelectBrush::mouseReleaseEvent(KoPointerEvent *event)
 {
-    if (m_dragging && e->button() == Qt::LeftButton) {
-        m_dragging = false;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
         applyToSelection(m_selection);
-        e->accept();
     }
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 void KisToolSelectBrush::activate(ToolActivation toolActivation, const QSet<KoShape*> &shapes)
@@ -201,7 +217,6 @@
 void KisToolSelectBrush::resetSelection()
 {
     updateCanvasPixelRect(m_selection.boundingRect());
-    m_dragging=false;
     m_selection = QPainterPath();
 }
 
Index: plugins/tools/tool_star/kis_tool_star.cc
===================================================================
--- plugins/tools/tool_star/kis_tool_star.cc	(revision 1177751)
+++ plugins/tools/tool_star/kis_tool_star.cc	(working copy)
@@ -55,8 +55,7 @@
 #include <recorder/kis_node_query_path.h>
 
 KisToolStar::KisToolStar(KoCanvasBase * canvas)
-        : KisToolShape(canvas, KisCursor::load("tool_star_cursor.png", 6, 6)),
-        m_dragging(false)
+        : KisToolShape(canvas, KisCursor::load("tool_star_cursor.png", 6, 6))
 {
     setObjectName("tool_star");
     m_innerOuterRatio = 40;
@@ -68,27 +67,27 @@
 }
 void KisToolStar::mousePressEvent(KoPointerEvent *event)
 {
-    if (!currentNode() || currentNode()->systemLocked()) {
-        return;
-    }
-    
-    if (canvas() && event->button() == Qt::LeftButton) {
-        m_dragging = true;
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
+
+        if (!currentNode() || currentNode()->systemLocked())
+            return;
+
+        setMode(KisTool::PAINT_MODE);
+
         m_dragStart = convertToPixelCoord(event);
         m_dragEnd = convertToPixelCoord(event);
         m_vertices = m_verticesSlider->value();
         m_innerOuterRatio = m_ratioSlider->value();
     }
-    if(m_dragging && (event->button() == Qt::MidButton || event->button() == Qt::RightButton)) {
-        //end painting, if calling the menu or the pop up palette. otherwise there is weird behaviour
-        m_dragging=false;
-        updatePreview();
+    else {
+        KisToolShape::mousePressEvent(event);
     }
 }
 
 void KisToolStar::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_dragging) {
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
         //Erase old lines
         updatePreview();
         if (event->modifiers() & Qt::AltModifier) {
@@ -100,16 +99,16 @@
         }
         updatePreview();
     }
+    else {
+        KisToolShape::mouseMoveEvent(event);
+    }
 }
 
 void KisToolStar::mouseReleaseEvent(KoPointerEvent *event)
 {
-    if (!canvas())
-        return;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
 
-    if (m_dragging && event->button() == Qt::LeftButton) {
-        m_dragging = false;
-
         if (m_dragStart == m_dragEnd)
             return;
 
@@ -168,18 +167,18 @@
             canvas()->addCommand(cmd);
         }
     }
+    else {
+        KisToolShape::mouseReleaseEvent(event);
+    }
 }
 
 void KisToolStar::paint(QPainter& gc, const KoViewConverter &converter)
 {
     Q_UNUSED(converter);
 
-    if (!m_dragging)
+    if (mode() != KisTool::PAINT_MODE)
         return;
 
-    if (!canvas())
-        return;
-
     vQPointF points = starCoordinates(m_vertices, m_dragStart.x(), m_dragStart.y(), m_dragEnd.x(), m_dragEnd.y());
 
     QPainterPath path;
Index: plugins/tools/tool_star/kis_tool_star.h
===================================================================
--- plugins/tools/tool_star/kis_tool_star.h	(revision 1177751)
+++ plugins/tools/tool_star/kis_tool_star.h	(working copy)
@@ -49,8 +49,6 @@
     QPointF m_dragStart;
     QPointF m_dragEnd;
     QRect m_final_lines;
-
-    bool m_dragging;
 private:
     vQPointF starCoordinates(int N, double mx, double my, double x, double y);
     void updatePreview();
Index: plugins/assistants/RulerAssistant/kis_ruler_assistant_tool.cc
===================================================================
--- plugins/assistants/RulerAssistant/kis_ruler_assistant_tool.cc	(revision 1177751)
+++ plugins/assistants/RulerAssistant/kis_ruler_assistant_tool.cc	(working copy)
@@ -73,38 +73,59 @@
 
 void KisRulerAssistantTool::mousePressEvent(KoPointerEvent *event)
 {
-    m_handleDrag = 0;
-    foreach(const KisPaintingAssistantHandleSP handle, m_handles) {
-        if (norm2(event->point - *handle) < 10) {
-            m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-            m_handleDrag = handle;
-            break;
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
+
+        setMode(KisTool::PAINT_MODE);
+
+        m_handleDrag = 0;
+        foreach(const KisPaintingAssistantHandleSP handle, m_handles) {
+            if (norm2(event->point - *handle) < 10) {
+                m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+                m_handleDrag = handle;
+                break;
+            }
         }
+        if (!m_handleDrag) {
+            event->ignore();
+        }
     }
-    if (!m_handleDrag) {
-        event->ignore();
+    else {
+        KisTool::mousePressEvent(event);
     }
 }
 
 
 void KisRulerAssistantTool::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_handleDrag) {
-        *m_handleDrag = event->point;
-        m_canvas->updateCanvas();
-    } else {
-        event->ignore();
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
+        if (m_handleDrag) {
+            *m_handleDrag = event->point;
+            m_canvas->updateCanvas();
+        } else {
+            event->ignore();
+        }
     }
+    else {
+        KisTool::mouseMoveEvent(event);
+    }
 }
 
 void KisRulerAssistantTool::mouseReleaseEvent(KoPointerEvent *event)
 {
-    if (m_handleDrag) {
-        m_handleDrag = 0;
-        m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
-    } else {
-        event->ignore();
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
+
+        if (m_handleDrag) {
+            m_handleDrag = 0;
+            m_canvas->updateCanvas(); // TODO update only the relevant part of the canvas
+        } else {
+            event->ignore();
+        }
     }
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 void KisRulerAssistantTool::paint(QPainter& _gc, const KoViewConverter &_converter)
Index: ui/canvas/kis_canvas2.cpp
===================================================================
--- ui/canvas/kis_canvas2.cpp	(revision 1177751)
+++ ui/canvas/kis_canvas2.cpp	(working copy)
@@ -674,14 +674,11 @@
 }
 
 
-bool KisCanvas2::handlePopupPaletteIsVisible(KoPointerEvent* e)
+bool KisCanvas2::handlePopupPaletteIsVisible()
 {
-    e->accept();
-
-    //TODO: port favoriteResourceManager to KisCanvas2, then enable this function.
-    if (e->button() && (Qt::LeftButton || Qt::MidButton || Qt::RightButton)
-        && favoriteResourceManager()
+    if (favoriteResourceManager()
         && favoriteResourceManager()->isPopupPaletteVisible()) {
+
         favoriteResourceManager()->slotShowPopupPalette();
         return true;
     }
Index: ui/canvas/kis_canvas2.h
===================================================================
--- ui/canvas/kis_canvas2.h	(revision 1177751)
+++ ui/canvas/kis_canvas2.h	(working copy)
@@ -212,7 +212,7 @@
 
     void createFavoriteResourceManager(KisPaintopBox*);
     KoFavoriteResourceManager* favoriteResourceManager();
-    bool handlePopupPaletteIsVisible(KoPointerEvent *);
+    bool handlePopupPaletteIsVisible();
 
 private:
     Q_DISABLE_COPY(KisCanvas2);
Index: ui/tool/kis_tool_ellipse_base.h
===================================================================
--- ui/tool/kis_tool_ellipse_base.h	(revision 1177751)
+++ ui/tool/kis_tool_ellipse_base.h	(working copy)
@@ -47,7 +47,6 @@
     QPointF m_dragCenter;
     QPointF m_dragStart;
     QPointF m_dragEnd;
-    bool m_dragging;
 };
 
 #endif // KIS_TOOL_ELLIPSE_BASE_H
Index: ui/tool/kis_tool_rectangle_base.cpp
===================================================================
--- ui/tool/kis_tool_rectangle_base.cpp	(revision 1177751)
+++ ui/tool/kis_tool_rectangle_base.cpp	(working copy)
@@ -25,7 +25,7 @@
 
 
 KisToolRectangleBase::KisToolRectangleBase(KoCanvasBase * canvas, const QCursor & cursor) :
-    KisToolShape(canvas, cursor), m_dragStart(0, 0), m_dragEnd(0, 0), m_dragging(false)
+    KisToolShape(canvas, cursor), m_dragStart(0, 0), m_dragEnd(0, 0)
 {
 }
 
@@ -34,41 +34,35 @@
     Q_UNUSED(converter);
     Q_ASSERT(currentImage());
 
-    if (m_dragging)
+    if (mode() == KisTool::PAINT_MODE)
         paintRectangle(gc, QRect());
 }
 
 void KisToolRectangleBase::deactivate()
 {
-    m_dragging=false;
     updateArea();
 }
 
 
-void KisToolRectangleBase::mousePressEvent(KoPointerEvent *e)
+void KisToolRectangleBase::mousePressEvent(KoPointerEvent *event)
 {
-    Q_ASSERT(canvas() && currentImage());
-    
-    if (!currentNode() || currentNode()->systemLocked()) {
-        return;
-    }
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
 
-    if (e->button() == Qt::LeftButton) {
-        QPointF pos = convertToPixelCoord(e);
-        m_dragging = true;
-        m_dragStart = m_dragCenter = m_dragEnd = pos;
-        e->accept();
+        if (!currentNode() || currentNode()->systemLocked())
+            return;
+
+        setMode(KisTool::PAINT_MODE);
+        m_dragStart = m_dragCenter = m_dragEnd = convertToPixelCoord(event);
     }
-    else if (e->button()==Qt::RightButton || e->button()==Qt::MidButton) {
-        m_dragging = false;
-        updateArea();
-        e->accept();
+    else {
+        KisToolPaint::mousePressEvent(event);
     }
 }
 
 void KisToolRectangleBase::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_dragging) {
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
         QPointF pos = convertToPixelCoord(event);
         updateArea();
 
@@ -101,24 +95,25 @@
 
         m_dragCenter = QPointF((m_dragStart.x() + m_dragEnd.x()) / 2,
                                (m_dragStart.y() + m_dragEnd.y()) / 2);
-    } else {
-        KisToolPaint::mouseReleaseEvent(event);
     }
+    else {
+        KisToolPaint::mouseMoveEvent(event);
+    }
 }
 
 void KisToolRectangleBase::mouseReleaseEvent(KoPointerEvent *event)
 {
-    Q_ASSERT(canvas() && currentImage());
-    if (!currentNode()) return;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
 
-    if (m_dragging && event->button() == Qt::LeftButton) {
         updateArea();
-        m_dragging = false;
         setCurrentNodeLocked(true);
         finishRect(QRectF(m_dragStart, m_dragEnd));
         setCurrentNodeLocked(false);
-        event->accept();
     }
+    else {
+        KisToolPaint::mouseReleaseEvent(event);
+    }
 }
 
 
Index: ui/tool/kis_tool_rectangle_base.h
===================================================================
--- ui/tool/kis_tool_rectangle_base.h	(revision 1177751)
+++ ui/tool/kis_tool_rectangle_base.h	(working copy)
@@ -47,7 +47,6 @@
     QPointF m_dragStart;
     QPointF m_dragEnd;
     QRect m_final_lines;
-    bool m_dragging;
 };
 
 #endif // KIS_TOOL_RECTANGLE_BASE_H
Index: ui/tool/kis_tool_paint.cc
===================================================================
--- ui/tool/kis_tool_paint.cc	(revision 1177751)
+++ ui/tool/kis_tool_paint.cc	(working copy)
@@ -66,6 +66,7 @@
 #include "kis_canvas_resource_provider.h"
 #include <recorder/kis_recorded_paint_action.h>
 #include <kis_cubic_curve.h>
+#include "kis_color_picker_utils.h"
 
 
 KisToolPaint::KisToolPaint(KoCanvasBase * canvas, const QCursor & cursor)
@@ -78,13 +79,14 @@
 
     m_opacity = OPACITY_OPAQUE_U8;
     m_compositeOp = 0;
-    
+
     updateTabletPressureSamples();
-    
+
     m_supportOutline = false;
-    
+
     KisCanvas2 * kiscanvas = static_cast<KisCanvas2*>(canvas);
     connect(kiscanvas->view()->resourceProvider(), SIGNAL(sigCompositeOpChanged(QString)), this, SLOT(slotSetCompositeMode(QString))); 
+    connect(this, SIGNAL(sigFavoritePaletteCalled(const QPoint&)), kiscanvas, SIGNAL(favoritePaletteCalled(const QPoint&)));
 }
 
 
@@ -123,26 +125,84 @@
 {
 }
 
+void KisToolPaint::mousePressEvent(KoPointerEvent *event)
+{
+    if(mode() == KisTool::HOVER_MODE &&
+       (event->button() == Qt::LeftButton || event->button() == Qt::RightButton) &&
+       event->modifiers() & Qt::ControlModifier &&
+       !specialModifierActive()) {
 
-void KisToolPaint::mouseReleaseEvent(KoPointerEvent *e)
+        setMode(SECONDARY_PAINT_MODE);
+        useCursor(KisCursor::pickerCursor());
+
+        m_toForegroundColor = event->button() == Qt::LeftButton;
+        pickColor(event->point, event->modifiers() & Qt::AltModifier,
+                  m_toForegroundColor);
+        event->accept();
+    }
+    else if(mode() == KisTool::HOVER_MODE &&
+            event->button() == Qt::RightButton &&
+            event->modifiers() == Qt::NoModifier &&
+            !specialModifierActive()) {
+
+        emit sigFavoritePaletteCalled(event->pos());
+        event->accept();
+    }
+    else {
+        KisTool::mousePressEvent(event);
+    }
+}
+
+void KisToolPaint::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (e->button() == Qt::RightButton) {
-        //CALLING POP UP PALETTE
-        emit sigFavoritePaletteCalled(e->pos());
+    if(mode() == KisTool::SECONDARY_PAINT_MODE) {
+        pickColor(event->point, event->modifiers() & Qt::AltModifier,
+                  m_toForegroundColor);
+        event->accept();
+    }
+    else {
+        KisTool::mouseMoveEvent(event);
+    }
+}
 
-//        KoResourceManager * resourceProvider = 0;
-//        if (canvas() && (resourceProvider = canvas()->resourceProvider())) {
-//            QVariant fg = resourceProvider->resource(KoCanvasResource::ForegroundColor);
-//            if (!fg.isValid()) return;
-//            QVariant bg = resourceProvider->resource(KoCanvasResource::BackgroundColor);
-//            if (!bg.isValid()) return;
-//            resourceProvider->setResource(KoCanvasResource::ForegroundColor, bg);
-//            resourceProvider->setResource(KoCanvasResource::BackgroundColor, fg);
-//        }
+void KisToolPaint::mouseReleaseEvent(KoPointerEvent *event)
+{
+    if(mode() == KisTool::SECONDARY_PAINT_MODE) {
+        setMode(KisTool::HOVER_MODE);
+        resetCursorStyle();
+        event->accept();
     }
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
+void KisToolPaint::keyPressEvent(QKeyEvent *event)
+{
+    KisTool::keyPressEvent(event);
+}
 
+void KisToolPaint::keyReleaseEvent(QKeyEvent* event)
+{
+    KisTool::keyReleaseEvent(event);
+}
+
+void KisToolPaint::pickColor(const QPointF &documentPixel,
+                             bool fromCurrentNode,
+                             bool toForegroundColor)
+{
+    int resource = toForegroundColor ?
+        KoCanvasResource::ForegroundColor : KoCanvasResource::BackgroundColor;
+
+    KisPaintDeviceSP device = fromCurrentNode ?
+        currentNode()->paintDevice() : image()->projection();
+
+    QPoint imagePoint = image()->documentToIntPixel(documentPixel);
+
+    canvas()->resourceManager()->
+        setResource(resource, KisToolUtils::pick(device, imagePoint));
+}
+
 QWidget * KisToolPaint::createOptionWidget()
 {
 
